<%@ page import="com.synametrics.xeams.rulesengine.*" %>
<%@ page import="java.util.*" %>

<%@ include file="PageHeader.jsp" %>
<%@ include file="SecondPageHeader.jsp" %>
<table width="100%" border="0" cellpadding="0" cellspacing="0">
    <tr align="left" valign="top">
    <td>
<table width="100%" border="0" cellspacing="2" cellpadding="4"><tr><td>

<h1>Trusted domains for SPF</h1>
Use of SPF prevents domain forgery. This means that if you trust a domain and that domain publishes SPF records
in DNS, you can give credit to such messages.

<h2>Example</h2>

Assume that you frequently get emails from a domain <b>"trustedDomain.com"</b> and you trust that no one
from this domain will send you spam messages. In addition, DNS for <b>"trustedDomain.com"</b> is configured
for SPF records and it publishes a list of IP address(es) that can send emails for this domain.

<p>
    <%= productName %> will give credit to all emails where the domain name is <b>"trustedDomain.com"</b> and
    the email is coming from one of the published IP address.
</p>

<h2>Should I mark my domain as trusted?</h2>
Yes. However, create an SPF record first in your DNS. This will prevent
someone from forging your email address. To learn about how to add an SPF
record refer to <a href="<%=com.synametrics.xeams.util.SMFrontResourceHandler.getResourceURL()%>Spf.htm"><%= productName %>'s web site</a>

<p>
    <br />
</p>
<%
String[] allDomains = com.synametrics.xeams.spf.SpfTrustedDomains.getInstance().getAllDomains();

String domainNames = "";

if(allDomains != null){


    StringBuffer buffer = new StringBuffer(4096);
	for(int i = 0; i < allDomains.length; i++){

		buffer.append(allDomains[i]).append("\r\n");
	}
    domainNames = buffer.toString();
}
%>


<form action="<%= request.getAttribute("appPath") %>" method="post">
    <table>
    	<tr>
            <td colspan="2"><h3>List of trusted domains</h3></td>

    	</tr>
        <tr>
            <td valign="top" rowspan="2"><textarea cols=35 rows=10 name="txtTrustedIP"><%=domainNames%></textarea></td>
            <td valign="top">Enter one domain per line. Every domain that you provide here is
            considered a trusted domain. It only makes sense to put domains that publishes SPF records
            in their DNS.
            <p>
                If you put domain names that do not publish SPF data, <%= productName %> will ignore that entry. To check
                if a particular domain publishes SPF data <a href="<%= response.encodeURL("FrontController?operation=195") %>">click here</a> and run a DNS Lookup query on the domain
            </p>
            </td>
        </tr>
        <tr>
            <td valign="bottom"><input type="submit" value="Save" /></td>
        </tr>

    </table>
    <input type="hidden" name="operation" value="98" />
</form>



</td></tr></table>
	 </td>
    <%@ include file="InnerRightGrey.jsp" %>
	</tr>
</table>

<%@ include file="SecondPageFooter.jsp" %>
<%@ include file="PageFooter.jsp" %>
