<%@ page import="com.synametrics.xeams.rulesengine.*" %>
<%@ page import="java.util.*" %>
<%@ page import="com.synametrics.xeams.net.*" %>
<%@ page import="com.synametrics.xeams.util.*" %>
<%@ page import="com.synametrics.commons.ip2country.*" %>

<%@ include file="PageHeader.jsp" %>
<%@ include file="SecondPageHeader.jsp" %>


<table width="100%" border="0" cellpadding="0" cellspacing="0">
<tr align="left" valign="top">
<td>



<table width="600" border="0" cellspacing="2" cellpadding="4">
      <tr>
        <td>
<%@ include file="RedBorderTableTop.jsp" %>
Intrusion Report
<%@ include file="RedBorderTableMiddle.jsp" %>



<%
int type;

    try{
        type = Integer.parseInt((String)request.getAttribute("type"));
    }catch(Exception e){
        out.println("Invalid type specified");
        return;
    }


    if(type == IntrusionDetector.SOCKETCONN){
%>

<br>
 <h2>Connections terminated immediately</h2>

 <p><b>Description</b><br>
Before two machines can talk to each other, a TCP/IP socket needs to be opened.
</p>
<p><b>Vulnerabilities</b><br>
If you see too many connections being terminated from a single IP address it means
that you can potentially be a victim of a "Denial of service attack", which occurs when a malicious user opens too
many TCP/IP connections on your machine but does not use them. Number of TCP/IP connections on a machine cannot
be more than 65536. Once all connections are used your server cannot accept any more emails.
</p>
<p><b>Recommended Action</b><br>
Block this the IP address at your network firewall.
</p>
<p><b>Caution</b><br>
A problem in either your or the client's network could result in such termination.
Therefore, do not block any IP if the number of terminations is not high.
</p>
<%
    }else if(type == IntrusionDetector.HELLO){
%>

 <br>
<h2>Connections terminated after Hello</h2>

<p><b>Description</b><br>
Hello is the first command sent by any client trying to send an email. In response, the server usually
sends a set of SMTP verbs that it supports.
</p>
<p><b>Vulnerabilities</b><br>
If you see too many connections being terminated from a single IP address it means
that some malicious user is trying to find out what SMTP server you are using and if it that server
is prone to some known vulnerablities that can be exploited.
</p>
<p><b>Recommended Action</b><br>
Block this the IP address at your network firewall.
</p>
<p><b>Caution</b><br>
A problem in either your or the client's network could result in such termination. Therefore, do not block
any IP if the number of terminations is not high.
</p>
<%

    }else if(type == IntrusionDetector.AUTH){
%>
 <br>
<h2>Connections terminated after authentication</h2>

<p><b>Description</b><br>
Most SMTP server requires user authentication before allowing relay. If a connection terminates after
authentication information is passed it means that a user who is trying to send an email could not
provide a valid user id and password.
</p>
<p><b>Vulnerabilities</b><br>
If you see too many connections being terminated from a single IP address it means
that some malicious user is trying to guess a user id and password on your email server. Once a
user id/password pair is compromised, anyone can send thousands of spam messages via your server.
</p>
<p><b>Recommended Action</b><br>
Black list this IP address in <%= productName %>.<br>
Make it a policy to have your users change their passwords frequently.
</p>
<p><b>Caution</b><br>
A problem in either your or the client's network could result in such termination.
It could also mean that a legitimate user within your company
forgot his/her password and is retrying. Therefore, do not block
any IP if the number of terminations is not high.
</p>
<%

    }else if(type == IntrusionDetector.MAIL_FROM){
%>

<%

    }else if(type == IntrusionDetector.RCPT_TO){
%>
<br>
<h2>Connections terminated after recipients list was provided</h2>

<p><b>Description</b><br>
A client sends a list of recipients before sending the actual message. The server then determines
if it can accept an email for the recipients passed by the client.
</p>
<p><b>Vulnerabilities</b><br>
If you see too many connections being terminated from a single IP address it means
that can potentially be a victim of a "Dictionary attack", which occurs when a malicious user sends emails to thousands
of users hoping that a small percentage will get through.<br>
Another possibility is that someone is trying to find out if you server is an open relay.
</p>
<p><b>Recommended Action</b><br>
Black list this IP address in <%= productName %>.
</p>
<p><b>Caution</b><br>
Incorrect email addresses in either TO, CC, or BCC can result in such termination.
A problem in either your or the client's network could also result in such termination.
Therefore, do not block any IP if the number of terminations is not high.
</p>
<%
    }else if(type == IntrusionDetector.TIMEOUT){

%>
<br>
<h2>Connections terminated immediately</h2>

 <p><b>Description</b><br>
Such termination occurs when the client does not send any data for a long time.
</p>
<p><b>Vulnerabilities</b><br>
If you see too many connections being terminated from a single IP address it means
that you can potentially be a victim of a "Denial of service attack", which occurs when a malicious user opens too
many TCP/IP connections on your machine but does not disconnect. Number of TCP/IP connections on a machine cannot
be more than 65536. Once all connections are used you server cannot accept any more emails.
</p>
<p><b>Recommended Action</b><br>
Block this the IP address at your network firewall.
</p>
<p><b>Caution</b><br>
A problem in either your or the client's network could result in such termination.
Therefore, do not block any IP if the number of terminations is not high.
</p>
<%
    }
%>

<h2>Summarized report</h2>
The following table shows TOP 50 IP addresses from where connections were terminated<br>

<table width="80%">
<tr>
<th align="left">IP Address</th>
<th align="left">Number of terminations</th>
<th align="left">Country of origin</th>
</tr>

<%
   List summaryArray = (java.util.List)request.getAttribute("summaryList");
   int total = 0;
   for(int i = summaryArray.size() - 1; i >= 0; i--, total++){

       if(total > 50) break;
       NameIntegerPair onePair = (NameIntegerPair)summaryArray.get(i);
       String countryName;

       if(!IP2CountryLookup.isInitialized()){
			countryName = "Unknown";
       }else{
        	countryName = IP2CountryLookup.getInstance().getCountryNameFromIP(onePair.getName());
       }
       out.println("<tr><td><a href=\"FrontController?operation=38&ip=" + onePair.getName() +
                    "\" target=_blank>" + onePair.getName() + "</a> </td><td>" + onePair.getValue() + "</td><td>" +
                    countryName +  "</td></tr>");
   }
%>
</table>





<h2>Detail report log</h2>
The following table shows last 250 connection attempts by IP address<br>
<table  width="80%">
<tr>
<th align="left">IP Address</th>
<th align="left">Time stamp</th>
</tr>
<%
   List logArray = (java.util.List)request.getAttribute("logArray");
   for(int i = 0; i < logArray.size(); i++){
       String oneLine = (String)logArray.get(i);
       out.println(IntrusionDetector.getInstance().formatLineToTableRow(oneLine));
   }
%>
</table>



<%@ include file="RedBorderTableBottom.jsp" %>
</td>
      </tr>
    </table>
</p>



</td>


<%@ include file="InnerRightGrey.jsp" %>
</tr>
</table>


<%@ include file="SecondPageFooter.jsp" %>
<%@ include file="PageFooter.jsp" %>
